#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Runtime.Serialization;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace SimpleCode
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : Form
    {
        private DockingManager mDockingManager1;
        private DockingManager mDockingManager2;
        private DockingManager mDockingManager3;
        private HostContainer mHostContainer1;
        private HostContainer mHostContainer2;
        private List<TestPanel> mPanelList1 = new List<TestPanel>();
        //private List<TestPanel> mPanelList2;
        private ImageList ilDocking;
        private MenuStrip menuStrip1;
        private ToolStripMenuItem saveLayoutToolStripMenuItem;
        private ToolStripMenuItem restoreLayoutToolStripMenuItem;
        private ToolStripMenuItem switchToolStripMenuItem;
		private IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support.
			//
			InitializeComponent();

			// The InitalizeDockingWindows method programmatically initializes the DockingManager 
			// and the various dockable controls.
			InitializeDockingWindows();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container( );
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( Form1 ) );
            this.ilDocking = new System.Windows.Forms.ImageList( this.components );
            this.menuStrip1 = new System.Windows.Forms.MenuStrip( );
            this.saveLayoutToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem( );
            this.restoreLayoutToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem( );
            this.switchToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem( );
            this.menuStrip1.SuspendLayout( );
            this.SuspendLayout( );
            // 
            // ilDocking
            // 
            this.ilDocking.ImageStream = ( (System.Windows.Forms.ImageListStreamer)( resources.GetObject( "ilDocking.ImageStream" ) ) );
            this.ilDocking.TransparentColor = System.Drawing.Color.Transparent;
            this.ilDocking.Images.SetKeyName( 0, "" );
            this.ilDocking.Images.SetKeyName( 1, "" );
            this.ilDocking.Images.SetKeyName( 2, "" );
            this.ilDocking.Images.SetKeyName( 3, "" );
            this.ilDocking.Images.SetKeyName( 4, "" );
            this.ilDocking.Images.SetKeyName( 5, "" );
            this.ilDocking.Images.SetKeyName( 6, "" );
            this.ilDocking.Images.SetKeyName( 7, "" );
            // 
            // menuStrip1
            // 
            this.menuStrip1.Items.AddRange( new System.Windows.Forms.ToolStripItem[] {
            this.saveLayoutToolStripMenuItem,
            this.restoreLayoutToolStripMenuItem,
            this.switchToolStripMenuItem} );
            this.menuStrip1.Location = new System.Drawing.Point( 0, 0 );
            this.menuStrip1.Name = "menuStrip1";
            this.menuStrip1.Size = new System.Drawing.Size( 813, 24 );
            this.menuStrip1.TabIndex = 4;
            this.menuStrip1.Text = "menuStrip1";
            // 
            // saveLayoutToolStripMenuItem
            // 
            this.saveLayoutToolStripMenuItem.Name = "saveLayoutToolStripMenuItem";
            this.saveLayoutToolStripMenuItem.Size = new System.Drawing.Size( 79, 20 );
            this.saveLayoutToolStripMenuItem.Text = "Save Layout";
            this.saveLayoutToolStripMenuItem.Click += new System.EventHandler( this.saveLayoutToolStripMenuItem_Click );
            // 
            // restoreLayoutToolStripMenuItem
            // 
            this.restoreLayoutToolStripMenuItem.Name = "restoreLayoutToolStripMenuItem";
            this.restoreLayoutToolStripMenuItem.Size = new System.Drawing.Size( 93, 20 );
            this.restoreLayoutToolStripMenuItem.Text = "Restore Layout";
            this.restoreLayoutToolStripMenuItem.Click += new System.EventHandler( this.restoreLayoutToolStripMenuItem_Click );
            // 
            // switchToolStripMenuItem
            // 
            this.switchToolStripMenuItem.Name = "switchToolStripMenuItem";
            this.switchToolStripMenuItem.Size = new System.Drawing.Size( 50, 20 );
            this.switchToolStripMenuItem.Text = "Switch";
            this.switchToolStripMenuItem.Click += new System.EventHandler( this.switchToolStripMenuItem_Click );
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 );
            this.BackColor = System.Drawing.Color.FromArgb( ( (int)( ( (byte)( 237 ) ) ) ), ( (int)( ( (byte)( 240 ) ) ) ), ( (int)( ( (byte)( 246 ) ) ) ) );
            this.ClientSize = new System.Drawing.Size( 813, 446 );
            this.Controls.Add( this.menuStrip1 );
            this.Icon = ( (System.Drawing.Icon)( resources.GetObject( "$this.Icon" ) ) );
            this.MainMenuStrip = this.menuStrip1;
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Simple Code";
            this.menuStrip1.ResumeLayout( false );
            this.menuStrip1.PerformLayout( );
            this.ResumeLayout( false );
            this.PerformLayout( );

		}
		#endregion

		private DockingManager CreateDockingManager(ContainerControl hostContainer)
		{
            DockingManager dockingManager = new DockingManager( );
            dockingManager.EnableContextMenu = true;
            dockingManager.ThemesEnabled = false;
            dockingManager.DragProviderStyle = DragProviderStyle.VS2005;
            dockingManager.PersistState = false;
            dockingManager.DisallowFloating = true;
            dockingManager.AutoHideInterval = 1;
            dockingManager.PaintBorders = true;

            if (hostContainer is Form)
                dockingManager.HostForm = (Form) hostContainer;
            else
                dockingManager.HostControl = hostContainer;

            dockingManager.ThemesEnabled = true;
            dockingManager.VisualStyle = VisualStyle.Office2003;
            dockingManager.PersistState = false;
            dockingManager.EnableContextMenu = true;
            dockingManager.ImageList = ilDocking;
            dockingManager.DockToFill = true;

		    return dockingManager;
		}

        private TestPanel CreateTestPanel( Color backColor, string description, DockingManager dockingManager )
        {
            TestPanel testPanel = new TestPanel( );
            testPanel.Name = description;

            testPanel.BackColor = backColor;
            dockingManager.DockControl( testPanel, dockingManager.HostControl, DockingStyle.Left, 200 );
            dockingManager.SetDockLabel( testPanel, description );
            //dockingManager.SetDockIcon( testPanel, 2 );

            mPanelList1.Add( testPanel );

            return testPanel;
        }

		// <samplecodeblock name="DockingWindows">
		// The method demonstrates how to programmatically initialize and set the docking windows layout.
		private void InitializeDockingWindows()
		{
			// Create the DockingManager instance and set this form as the host form.
            DockingManager.AnimationStep = 5;

            mDockingManager1 = CreateDockingManager(this);

            mHostContainer1 = new HostContainer();
            mHostContainer1.Name = "HostContainer1";
            mDockingManager1.DockControl( mHostContainer1, this, DockingStyle.Left, 200 );
            mDockingManager1.SetDockLabel( mHostContainer1, "HostContainer1" );
            //mDockingManager1.SetDockIcon( mHostContainer1, 5 );

            mHostContainer2 = new HostContainer( );
            mHostContainer2.Name = "HostContainer2";
            mDockingManager1.DockControl( mHostContainer2, this, DockingStyle.Left, 200 );
            mDockingManager1.SetDockLabel( mHostContainer2, "HostContainer2" );
            mDockingManager1.SetDockIcon( mHostContainer2, 5 );

            mDockingManager2 = CreateDockingManager( mHostContainer1 );
            mDockingManager3 = CreateDockingManager( mHostContainer2 );

		    TestPanel panel;
            panel = CreateTestPanel( Color.DarkTurquoise, "TestPanel1", mDockingManager2 );
            panel.Name = "Test1";
            panel = CreateTestPanel( Color.DarkBlue, "TestPanel2", mDockingManager2 );
            panel.Name = "Test2";
            panel = CreateTestPanel( Color.Green, "TestPanel3", mDockingManager3 );
            panel.Name = "Test3";
            panel = CreateTestPanel( Color.DodgerBlue, "TestPanel4", mDockingManager3 );
            panel.Name = "Test4";

            saveLayoutToolStripMenuItem_Click(null, null);
        }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

        private void saveLayoutToolStripMenuItem_Click( object sender, EventArgs e )
        {
            // Save docking state of docking manager 1
            AppStateSerializer serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest1.txt" );
            mDockingManager1.SaveDockState( serializer );
            serializer.PersistNow( );

            // Save docking state of docking manager 2
            serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest2.txt" );
            mDockingManager2.SaveDockState( serializer );
            serializer.PersistNow( );

            // Save docking state of docking manager 3
            serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest3.txt" );
            mDockingManager3.SaveDockState( serializer );
            serializer.PersistNow( );
        }

        private void restoreLayoutToolStripMenuItem_Click( object sender, EventArgs e )
        {
            // Restore docking manager 1
            AppStateSerializer serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest1.txt" );
            if( !mDockingManager1.LoadDockState( serializer ) )
                MessageBox.Show( "LoadDocState failed for docking manager 1" );

            // Restore docking manager 2
            serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest2.txt" );
            if( !mDockingManager2.LoadDockState( serializer ) )
                MessageBox.Show( "LoadDocState failed for docking manager 2" );

            // Restore docking manager 2
            serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest3.txt" );
            if( !mDockingManager3.LoadDockState( serializer ) )
                MessageBox.Show( "LoadDocState failed for docking manager 3" );
        }

        private void switchToolStripMenuItem_Click( object sender, EventArgs e )
        {
            AppStateSerializer serializer = new AppStateSerializer( SerializeMode.XMLFile, "DockingStateTest2.txt" );
            if( !mDockingManager3.LoadDockState( serializer ) )
                MessageBox.Show( "LoadDocState failed for docking manager 3" );
        }
	    
	}
}
